Subject: Re: bug#69246: 30.0.50; persistent key input delay after using vc commands in pgtk

From: Eli Zaretskii <[email-masked]>
Date: Thu, 22 Feb 2024 08:45:04 +0200

> From: Po Lu <[email-masked]>
> Cc: Eli Zaretskii <[email-masked]>,  [email-masked]
> Date: Thu, 22 Feb 2024 09:20:11 +0800
> 
> Nick OBrien <[email-masked]> writes:
> 
> > Running "GTK_IM_MODULE=none emacs -Q" and following the steps in the original
> > bug report, the lag appears to be fixed. I reproduced it three times, and each
> > time there was no lag. For reference, I tried again with GTK_IM_MODULE=fcitx
> > (how it was in the original bug report) and 4/4 times I experienced the lag.
> >
> > I haven't ever experienced this sort of lag in Firefox or signal-desktop, two
> > gtk3 apps I regularly use. And just to clarify, the lag doesn't seem to lengthen
> > the interval between generated repeat key-presses. The repeated key-presses just
> > seem /choppier/, as if the frame-rate is lower. The lag is most obvious when
> > holding down a key and releasing after a single key appears.
> >
> > I'll try using my normal config with GTK_IM_MODULE=none and see if I experience
> > the lag in everyday use.
> 
> I suppose your problem is that fcitx cannot tolerate programs responding
> to keyboard input in a manner unconventional for a GTK program, as Emacs
> does.

What is the "unconventional manner" in which GTK Emacs responds to
keyboard input?  And why do we do that?